// Copyright 2019 The age Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package age

import (
	"errors"

	"filippo.io/age/internal/format"
)

// aeadEncrypt encrypts a message with a one-time key.
func aeadEncrypt(key, plaintext []byte) ([]byte, error) {
	panic("chacha20poly1305 cipher not available")
}

var errIncorrectCiphertextSize = errors.New("encrypted value has unexpected length")

// aeadDecrypt decrypts a message of an expected fixed size.
//
// The message size is limited to mitigate multi-key attacks, where a ciphertext
// can be crafted that decrypts successfully under multiple keys. Short
// ciphertexts can only target two keys, which has limited impact.
func aeadDecrypt(key []byte, size int, ciphertext []byte) ([]byte, error) {
	panic("chacha20poly1305 cipher not available")
}

func headerMAC(fileKey []byte, hdr *format.Header) ([]byte, error) {
	panic("hkdf cipher not available")
}

func streamKey(fileKey, nonce []byte) []byte {
	panic("chacha20poly1305 cipher not available")
}
